<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:c="http://java.sun.com/jsp/jstl/core"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <h1>#{messages['gazelle.ordermanager.LaboratoryLabelBroker']}</h1>
            <gri:panel>
                <f:facet name="header">#{messages['gazelle.ordermanager.QueryForLabelDelivery']}</f:facet>
                <s:div id="globalDiv">
                    <ui:include src="/configuration/initiatorFrame.xhtml">
                        <ui:param name="actorKeyword" value="#{queryForLabel.sutActor.keyword}"/>
                        <ui:param name="diagramImg" value="diag/LAB-62-LIP-SUT.png"/>
                        <ui:param name="simuApplication" value="#{messages['gazelle.ordermanager.OMLABLB']}"/>
                        <ui:param name="simuFacility" value="#{messages['gazelle.ordermanager.IHE']}"/>
                        <ui:param name="sectionsToReRender" value="requestParameters"/>
                        <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                        <ui:param name="simulatorConfigurationName"
                                  value="#{messages['gazelle.ordermanager.LabelBrokerSimulator']}"/>
                        <ui:param name="availableSuts"
                                  value="#{hl7v2ResponderSUTConfiguration.getAllConfigurationsForSelection('LAB-62', 'MLLP')}"/>
                    </ui:include>
                    <br/>
                    <s:div id="requestParameters">
                        <s:div rendered="#{queryForLabel.hl7Messages == null}">
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.QueryParameters']}
                                </f:facet>
                                <div class="form-horizontal">
                                    <!-- include in <div class="form-horizontal"></div>-->
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                                id="qpd3Decorate">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.PatientIdentifier_2']}</ui:define>
                                        <ui:param name="id" value="qpd3"/>
                                        <h:inputText value="#{queryForLabel.patientId}"
                                                     id="qpd3" tabindex="1" styleClass="form-control"
                                                     validator="#{queryForLabel.validateParameter}">
                                            <a4j:ajax event="blur" render="qpd3Decorate"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                                id="qpd4Decorate">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.VisitNumber']}</ui:define>
                                        <ui:param name="id" value="qpd4"/>
                                        <h:inputText value="#{queryForLabel.visitNumber}"
                                                     tabindex="1" styleClass="form-control"
                                                     validator="#{queryForLabel.validateParameter}"
                                                     id="qpd4">
                                            <a4j:ajax event="blur" render="qpd4Decorate"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                                id="qpd5Decorate">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.PlacerGroupNumber']}</ui:define>
                                        <ui:param name="id" value="qpd5"/>
                                        <h:inputText id="qpd5"
                                                     value="#{queryForLabel.placerGroupNumber}"
                                                     tabindex="1" styleClass="form-control"
                                                     validator="#{queryForLabel.validateParameter}">
                                            <a4j:ajax event="blur" render="qpd5Decorate"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                                id="qpd6Decorate">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.PlacerOrderNumber_2']}</ui:define>
                                        <ui:param name="id" value="qpd6"/>
                                        <h:inputText id="qpd6"
                                                     value="#{queryForLabel.placerOrderNumber}"
                                                     tabindex="1" styleClass="form-control"
                                                     validator="#{queryForLabel.validateParameter}">
                                            <a4j:ajax event="blur" render="qpd6Decorate"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                                id="qpd7Decorate">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.FillerOrderNumber_2']}</ui:define>
                                        <ui:param name="id" value="qpd7"/>
                                        <h:inputText id="qpd7"
                                                     value="#{queryForLabel.fillerOrderNumber}"
                                                     tabindex="1" styleClass="form-control"
                                                     validator="#{queryForLabel.validateParameter}">
                                            <a4j:ajax event="blur" render="qpd7Decorate"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.SearchPeriodstart']})</ui:define>
                                        <ui:param name="id" value="start"/>
                                        <a4j:outputPanel id="start" layout="block">
                                            <rich:calendar value="#{queryForLabel.startDate}"
                                                           locale="#{localeSelector.localeString}"
                                                           datePattern="dd/MM/yyyy HH:mm" showApplyButton="true"/>
                                        </a4j:outputPanel>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                        <ui:define name="label">#{messages['gazelle.ordermanager.SearchPeriodend']})</ui:define>
                                        <ui:param name="id" value="end"/>
                                        <a4j:outputPanel id="end" layout="block">
                                            <rich:calendar value="#{queryForLabel.endDate}"
                                                           locale="#{localeSelector.localeString}"
                                                           datePattern="dd/MM/yyyy HH:mm" showApplyButton="true"/>
                                        </a4j:outputPanel>
                                    </s:decorate>
                                </div>
                                <f:facet name="footer">
                                    <a4j:commandButton actionListener="#{queryForLabel.resetParameters()}"
                                                       value="#{messages['gazelle.ordermanager.CleanUpParameters']}"
                                                       render="requestParameters"
                                                       styleClass="gzl-btn-orange"/>
                                    <a4j:commandButton actionListener="#{queryForLabel.sendMessage()}"
                                                       value="#{messages['gazelle.ordermanager.SendQuery']}"
                                                       render="hl7MessagesDiv,requestParameters"
                                                       styleClass="gzl-btn-blue"/>
                                </f:facet>
                            </gri:panel>
                        </s:div>
                    </s:div>
                    <!--  response div -->
                    <s:div id="hl7MessagesDiv">
                        <gri:panel rendered="#{queryForLabel.hl7Messages != null}">
                            <f:facet name="header">#{messages['gazelle.ordermanager.QueryReport']}</f:facet>
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.simu.Response']}</f:facet>
                                <s:div rendered="#{empty queryForLabel.receivedRequests}"
                                       styleClass="gzl-alert gzl-alert-orange">
                                    <h:outputText value="#{messages['gazelle.ordermanager.NoLabelMatchesOnLabelInformationProviderSide']}"/>
                                </s:div>
                                <s:div rendered="#{not empty queryForLabel.receivedRequests}"
                                       styleClass="gzl-alert gzl-alert-blue">
                                    <h:outputText value="#{queryForLabel.receivedRequests.size()} #{messages['gazelle.ordermanager.LabelsMatchesYourCriteriaSeeTheListBelow']}"/>
                                </s:div>
                                <rich:dataTable rendered="#{queryForLabel.receivedRequests != null}"
                                                value="#{queryForLabel.receivedRequests}" var="req" render="ds"
                                                id="reqlist"
                                                rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                                    <ui:include src="/lab/specimenColumns.xhtml">
                                        <ui:param name="specimen" value="#{req}"/>
                                    </ui:include>
                                    <g:column>
                                        <f:facet name="header">#{messages['net.ihe.gazelle.patgen.Actions']}</f:facet>
                                        <h:outputLink
                                                value="#{applicationConfiguration.getValueOfVariable('application_url')}#{specimenBrowser.getPermanentLink(req.id)}"
                                                title="#{messages['gazelle.ordermanager.MoreDetails']}">
                                            <s:span styleClass="gzl-icon-search "/>
                                        </h:outputLink>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="ds"/>
                                            <ui:param name="dataTableId" value="reqlist"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </gri:panel>
                            <gri:panel>
                                <f:facet name="header">#{messages['gazelle.ordermanager.ExchangedMessages']}</f:facet>
                                <ui:include src="/messages/message_table.xhtml">
                                    <ui:param name="hl7Messages" value="#{queryForLabel.hl7Messages}"/>
                                </ui:include>
                            </gri:panel>
                            <f:facet name="footer">
                                <a4j:commandButton value="#{messages['gazelle.ordermanager.SendAnotherQuery']}"
                                                   actionListener="#{queryForLabel.init()}"
                                                   styleClass="gzl-btn-blue"
                                                   render="hl7MessagesDiv,requestParameters"/>
                            </f:facet>
                        </gri:panel>
                    </s:div>
                </s:div>
            </gri:panel>
        </h:form>
    </ui:define>
</ui:composition>
